<?php
/**
 * @package			No Boss Extensions
 * @subpackage  	No Boss Calendar
 * @author			No Boss Technology <contact@nobosstechnology.com>
 * @copyright		Copyright (C) 2020 No Boss Technology. All rights reserved.
 * @license			GNU Lesser General Public License version 3 or later; see <https://www.gnu.org/licenses/lgpl-3.0.en.html>
 */

defined('_JEXEC') or die();
$s = "";

// Setado para exibir navegacao abaixo do calendario: coloca estilo flex que muda posicao para baixo
if ((!empty($custom->position_nav)) && ($custom->position_nav == 'down')){
    $s .= "
    .{$module->name} .nb-calendar{
        flex-direction: column-reverse;
        display: flex;
    }
    ";
}

// Estilo hover para link em botao
$s .=  
".{$module->name} .nb-calendar__event .nb-event_button a:hover,
.{$module->name} .nb-calendar__event .nb-event_button span:hover{
    {$custom->button_style_hover}
}
";

// Acesso mobile
$s .= "@media screen and (max-width: 767px){
        .{$module->name}{
            {$sectionStyleMobile}
        }
        .{$module->name} .nb-calendar__title{
            {$titleStyleMobile}
        }
        .{$module->name} .nb-calendar__subtitle{
            {$subtitleStyleMobile}
        }
        .{$moduleName} .nb-event__title{
            {$custom->events_title_style_mobile}
        }
        .{$moduleName} .nb-event__description{
            {$custom->events_subtitle_style_mobile}
        }
        .{$moduleName} .nb-event__date{
            {$custom->events_date_style_mobile}
        }
        .{$moduleName} .nb-event__time{
            {$custom->events_schedule_style_mobile}
        }
        .{$moduleName} .nb-event__localization{
            {$custom->events_address_style_mobile}
        }";

        $s .= "
        .{$module->name} .nb-calendar__body{
            {$custom->gridListMobile}
        }";

        // Estilo para link em botao
        $s .= "
        .{$module->name} .nb-calendar__event .nb-event_button a,
        .{$module->name} .nb-calendar__event .nb-event_button span{
            {$custom->button_style_mobile}
        }";
$s .= "}";

// Acesso tablet
$s .= "@media only screen and (min-width: 768px) and (max-width: 991px){";
    if($theme == 'model2'){
        $s .= "
        .{$module->name}.{$module->name}--model2 .nb-calendar__body{
            {$custom->gridListTablet}
        }";
    }
$s .= "}";

// Acesso desktop
$s .= "@media screen and (min-width: 992px){";
    if($theme == 'model2'){
        $s .= "
        .{$module->name}.{$module->name}--model2 .nb-calendar__body{
            {$custom->gridList}
        }";
    }
$s .= "}";

// chama função que adiciona prefixo em todo o estilo que foi concatenado na variável $s 
$assetsObject->addStyleWithPrefix($s); 

?>
